unit hiImgMask;

interface

uses Windows,Kol,Share,Debug;

type
  THIImgMask = class(TDebug)
   private
    src:PBitmap;
   public  
    _prop_Color:TColor;
    _prop_Background: TColor;
    _data_Color:THI_Event;
    _data_Background:THI_Event;
    _data_Bitmap:THI_Event;
    _event_onResult:THI_Event;

    destructor Destroy; override;
    procedure _work_doImgMask(var _Data:TData; Index:word);
    procedure _var_Result(var _Data:TData; Index:word);
  end;


implementation

destructor THIImgMask.Destroy;
begin
   if Assigned(src) then src.free;
   inherited;
end;

procedure THIImgMask._work_doImgMask;

var   bmp: PBitmap;
      i, j, c, b: integer;
begin
   bmp := ReadBitmap(_Data,_data_Bitmap,nil);
   if (bmp = nil) or bmp.Empty then exit;
   c := ReadInteger(_Data, _data_Color, _prop_Color);
   b := ReadInteger(_Data, _data_Background, _prop_Background);
   if not Assigned(src) then 
   src := NewBitmap(0,0);
   src.handle := CopyImage( bmp.Handle, IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION );
   src.PixelFormat := pf24bit;
    for I:=0 to src.Height do for j:=0 to src.Width do if src.Pixels[j,i] <> b then src.Pixels[j,i]:= c;
   _hi_OnEvent(_event_onResult, src);
end;

procedure THIImgMask._var_Result;
begin
   if (src = nil) or src.Empty then exit;
   dtBitmap(_Data, src);
end;

end.
